var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};


lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

function fetchMediaLibrary() {
  try {
    lInfo.logln('start fetchMediaLibrary');
    cloudService.fetchMediaLibrary(function (oData) {
      lInfo.logln('getting fetchMediaLibrary: ' + JSON.stringify(oData));
      var mediaObject = null;
      if (oData!=null) {
        if (oData.ReturnCode != null && oData.ReturnCode == 0) {
          mediaObject = JSON.stringify(oData.Response.MediaLibraryTreeList);
          lInfo.logln("fetchMediaLibrary returnCode="+oData.ReturnCode);
        }
      }
      else 
        lInfo.logln("fetchMediaLibrary empty return");
      
      var evt = new Event("sonos-controller-cloud-value", {value:mediaObject});
      evt.raise();
    });
    
  } 
  catch (e) {
    lWarn.logln('fetchMediaLibrary error ' + e);
  }
}

function fetchSpeechConfiguration() {
  try {
    lInfo.logln('start fetchSpeechConfiguration');
    cloudService.fetchText2SpeechConf(function (oData) {
      lInfo.logln('getting fetchSpeechConfiguration: ' + JSON.stringify(oData));
      var mediaConfig = new Object();
      if (oData!=null) {
        if (oData.ReturnCode != null && oData.ReturnCode == 0) {
          mediaConfig.config = oData.Response.LanguageCodeList;
          mediaConfig.maxCalls = oData.Response.MaxTextToSpeechCalls;
          mediaConfig.maxTextLength = oData.Response.MaxTextToSpeechLength;
          
          lInfo.logln("fetchSpeechConfiguration returnCode="+oData.ReturnCode);
        }
      }
      else 
        lInfo.logln("fetchSpeechConfiguration empty return");
      
      var evt = new Event("sonos-controller-cloud-value-config", {value:JSON.stringify(mediaConfig)});
      evt.raise();
    });
    
  } catch (e) {
    lWarn.logln('fetchMediaLibrary error ' + e);
  }
}

function createTextSound(sFolder, sLang, sVoiceName, sText) {
  try {
    lInfo.logln('start createTextSound');
    cloudService.createTextSound(sFolder, sLang, sVoiceName, sText, function (oData) {
      lInfo.logln('getting createTextSound: ' + JSON.stringify(oData));
      var mediaConfig = new Object();
      if (oData!=null) {
        if (oData.ReturnCode != null && oData.ReturnCode == 0) {
          mediaConfig.fileGUID = oData.Response.TextToSpeechVoiceFileGuid;
          
          lInfo.logln("createTextSound returnCode="+oData.ReturnCode);
        }
      }
      else 
        lInfo.logln("createTextSound empty return");
      
      var evt = new Event("sonos-controller-cloud-value-t2s", {value:JSON.stringify(mediaConfig)});
      evt.raise();
    });
  } catch (e) {
    lWarn.logln('fetchMediaLibrary error ' + e);
  }
}


if (raisedEvent.name === 'event-sonos-cloud') {
	Property.load();
  
  if (raisedEvent.parameter.actions=='getMediaLibrary') {
   lWarn.logln('getMediaLibrary'); 
   fetchMediaLibrary();
  }
  else if (raisedEvent.parameter.actions=='getSpeechConf') {
   lWarn.logln('getSpeechConf'); 
   fetchSpeechConfiguration();
  }
  else if (raisedEvent.parameter.actions=='createTextSound') {
   lWarn.logln('createTextSound'); 
   var sObject = JSON.parse(unescape(raisedEvent.parameter.value));
   if (sObject != null)
     createTextSound(sObject.sLang, sObject.sVoiceName, sObject.sText);
  }
}